package xyz.etztech.qol.listeners;

import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.configuration.ConfigurationSection;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.event.player.PlayerLoginEvent;
import xyz.etztech.qol.QoL;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

public class JoinListener implements Listener {

    private QoL plugin;

    public JoinListener(QoL plugin) {
        this.plugin = plugin;
    }

    @EventHandler
    public void onJoin(PlayerJoinEvent event) {

        // First login
        final Player player = event.getPlayer();
        if (!player.hasPlayedBefore()) {
            Bukkit.getScheduler().scheduleSyncDelayedTask(plugin, () -> {
                for (Player p : Bukkit.getServer().getOnlinePlayers()) {
                    if (player != p) {
                        p.sendMessage(ChatColor.GREEN + player.getName() + " is new here! Be sure to welcome them!");
                    } else {
                        p.sendMessage(ChatColor.GREEN + "Welcome, " + player.getName() + "! Check out /rules and then /apply!");
                    }
                }
            }, 30); // ~1.5 seconds
        }

        // Queue commands
        List<?> queues = plugin.getConfig().getList("queue");
        for (int i = 0; i < queues.size(); i++) {
            try {
                LinkedHashMap queue = (LinkedHashMap) queues.get(i);
                String permission = (String) queue.get("permission");
                if (player.hasPermission(permission)) {
                    for (String command : (List<String>) queue.get("commands")) {
                        plugin.runTask(command.replace("<player>", player.getName()));
                    }
                }
            } catch (Exception ignored) {}
        }

    }

}
